unit Editser;

interface

{ This example shows how to invoke a Series Editor dialog,
  separately from the Chart editor.
}
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Series, TeEngine, StdCtrls, Buttons, ExtCtrls, TeeProcs,
  Chart;

type
  TFormShowSeriesEditor = class(TForm)
    Chart1: TChart;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Series1: TLineSeries;
    Series2: TBarSeries;
    Series3: TPointSeries;
    procedure BitBtn4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}
Uses EditChar;

{ This method shows the Series editor }
Procedure EditOneSeries(AOwner:TControl; ASeries:TChartSeries);
var tmpClass:TFormClass;
    tmp:TForm;
begin
  tmpClass:=TFormClass(GetClass(ASeries.GetEditorClass));
  if Assigned(tmpClass) then
  begin
    tmp:=tmpClass.Create(AOwner);
    With tmp do
    try
      Position:=poScreenCenter;
      BorderStyle:=bsDialog;
      BorderIcons:=[biSystemMenu];
      Caption:='Editing '+ASeries.Name+' in '+AOwner.ClassName;
      Tag:=Longint(ASeries);
      Height:=220;
      ShowModal;
    finally
      Free;
    end;
  end
  else raise Exception.Create('Cannot find Series editor Form: '+ASeries.GetEditorClass);
end;

procedure TFormShowSeriesEditor.BitBtn4Click(Sender: TObject);
begin
  Close;
end;

procedure TFormShowSeriesEditor.FormCreate(Sender: TObject);
begin
  Series1.FillSampleValues(28);
  Series2.FillSampleValues(8);
  Series3.FillSampleValues(28);
end;

procedure TFormShowSeriesEditor.BitBtn1Click(Sender: TObject);
begin
  EditOneSeries(Self,Series1);
end;

procedure TFormShowSeriesEditor.BitBtn2Click(Sender: TObject);
begin
  EditOneSeries(Self,Series2);
end;

procedure TFormShowSeriesEditor.BitBtn3Click(Sender: TObject);
begin
  EditOneSeries(Self,Series3);
end;

end.
