{*********************************************}
{ TeeChart Delphi Component Library           }
{ Extended Chart Series Example               }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit Menupro;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, StdCtrls, ExtCtrls;

type
  TExtendedSeriesForm = class(TForm)
    GroupBox1: TGroupBox;
    BCandle: TBitBtn;
    BCurvefitting: TBitBtn;
    BPolar: TBitBtn;
    BMomentum: TBitBtn;
    BErrorBar: TBitBtn;
    BMovingAve: TBitBtn;
    BitBtn1: TBitBtn;
    BSurface: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Panel1: TPanel;
    BBezier: TBitBtn;
    Label6: TLabel;
    BRadar: TBitBtn;
    Label9: TLabel;
    BContour: TBitBtn;
    Label10: TLabel;
    Label11: TLabel;
    BPoint3D: TBitBtn;
    BErrStd: TBitBtn;
    Label12: TLabel;
    Label13: TLabel;
    BTrend: TBitBtn;
    Label15: TLabel;
    BStdDev: TBitBtn;
    Label14: TLabel;
    BCumu: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BCandleClick(Sender: TObject);
    procedure BCurvefittingClick(Sender: TObject);
    procedure BMomentumClick(Sender: TObject);
    procedure BMovingAveClick(Sender: TObject);
    procedure BErrorBarClick(Sender: TObject);
    procedure BPolarClick(Sender: TObject);
    procedure BSurfaceClick(Sender: TObject);
    procedure BBezierClick(Sender: TObject);
    procedure BRadarClick(Sender: TObject);
    procedure BContourClick(Sender: TObject);
    procedure BPoint3DClick(Sender: TObject);
    procedure BTrendClick(Sender: TObject);
    procedure BStdDevClick(Sender: TObject);
    procedure BErrStdClick(Sender: TObject);
    procedure BCumuClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}
Uses EditPro,   { <--- Important to access the Editor Dialog with
                       Extended Series }
     Candle,
     CurvFit,
     Momentu,
     MovinAve,
     Surface,
     UErrorBa,
     UPolar,
     UBezie,
     UContou,
     UErrStd,
     UPo3D,
     URadar,
     UStdDev,
     UTrend,
     Features,
     UDemoCum;

procedure TExtendedSeriesForm.FormCreate(Sender: TObject);
begin
  if Screen.Width<800 then
     ShowMessage('Warning: '+#13+#10+
                 'This Demo is best viewed with a Screen'+#13+#10+
                 'resolution of 800x600 or greater,'+#13+#10+
                 'and a Color Depth of 256 or greater.'+#13+#10+
                 '16K Colors is also better than 256 Colors.');
end;

procedure TExtendedSeriesForm.BCandleClick(Sender: TObject);
begin
  ShowForm(TCandleForm);
end;

procedure TExtendedSeriesForm.BCurvefittingClick(Sender: TObject);
begin
  ShowForm(TCurveFittingForm);
end;

procedure TExtendedSeriesForm.BMomentumClick(Sender: TObject);
begin
  ShowForm(TMomentumForm);
end;

procedure TExtendedSeriesForm.BMovingAveClick(Sender: TObject);
begin
  ShowForm(TMovingAveForm);
end;

procedure TExtendedSeriesForm.BErrorBarClick(Sender: TObject);
begin
  ShowForm(TErrorBarForm);
end;

procedure TExtendedSeriesForm.BPolarClick(Sender: TObject);
begin
  ShowForm(TPolarForm);
end;

procedure TExtendedSeriesForm.BSurfaceClick(Sender: TObject);
begin
  ShowForm(TSurfaceForm);
end;

procedure TExtendedSeriesForm.BBezierClick(Sender: TObject);
begin
  ShowForm(TBezierForm);
end;

procedure TExtendedSeriesForm.BRadarClick(Sender: TObject);
begin
  ShowForm(TRadarForm);
end;

procedure TExtendedSeriesForm.BContourClick(Sender: TObject);
begin
  ShowForm(TContourForm);
end;

procedure TExtendedSeriesForm.BPoint3DClick(Sender: TObject);
begin
  ShowForm(TPoint3DForm);
end;

procedure TExtendedSeriesForm.BTrendClick(Sender: TObject);
begin
  ShowForm(TTrendForm);
end;

procedure TExtendedSeriesForm.BStdDevClick(Sender: TObject);
begin
  ShowForm(TStdDevForm);
end;

procedure TExtendedSeriesForm.BErrStdClick(Sender: TObject);
begin
  ShowForm(TErrStdForm);
end;

procedure TExtendedSeriesForm.BCumuClick(Sender: TObject);
begin
  ShowForm(TCummuForm);
end;

end.
