{*********************************************}
{ TeeChart Delphi Component Library           }
{ Momentum Series Type Demo                   }
{ Copyright (c) 1995-1996 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit Momentu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Chart, Series, ExtCtrls, StatChar, StdCtrls, Curvfitt,
  Spin, Teengine, Buttons,  TeeProcs;

type
  TMomentumForm = class(TForm)
    Chart1: TChart;
    Stock: TLineSeries;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    MomentumSeries1: TLineSeries;
    TeeFunction1: TMomentumFunction;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MomentumForm: TMomentumForm;

implementation

{$R *.DFM}

Uses EditChar,CustEdit; { <-- for Chart & Series Editing }

procedure TMomentumForm.FormCreate(Sender: TObject);
begin
  Stock.FillSampleValues(200); { <-- Some random points }
end;

procedure TMomentumForm.CheckBox1Click(Sender: TObject);
begin
  Timer1.Enabled:=CheckBox1.Checked;
end;

procedure TMomentumForm.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;
  With Stock do
  Begin
    Delete(0); { <-- remove the first point }
    { Add a new random point }
    AddXY( XValues.Last+1,
           YValues.Last+(Random(ChartSamplesMax)-(ChartSamplesMax/2)),
           '',clTeeColor);
    { Recalculate Momentum }
    RefreshSeries;
  end;
  Timer1.Enabled:=True;
end;

procedure TMomentumForm.SpinEdit1Change(Sender: TObject);
begin
  MomentumSeries1.FunctionType.Period:=SpinEdit1.Value;
end;

procedure TMomentumForm.BitBtn1Click(Sender: TObject);
begin
  EditChart(Self,Chart1); { <-- Quite simple }
end;

end.
