{*********************************************}
{ TeeChart Delphi Component Library           }
{ New Features in TeeChart Pro 4.0 Demo       }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
{$I TeeDefs.inc}
unit NewPro4;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TMenuExtended = class(TForm)
    Panel2: TPanel;
    Label2: TLabel;
    BBackWall: TButton;
    BGradient: TButton;
    BDepthAxis: TButton;
    BMultiLabels: TButton;
    BMultiAxis: TButton;
    BLogAxis: TButton;
    BDraw3D: TButton;
    BMultiRowLegend: TButton;
    BFuncRange: TButton;
    BEditor: TButton;
    BPreviewer: TButton;
    BArray: TButton;
    BMarks: TButton;
    BZOrder: TButton;
    BCandle: TButton;
    BExploded: TButton;
    BOtherPie: TButton;
    BCommander: TButton;
    BListBox: TButton;
    Button20: TButton;
    BNewSeries: TButton;
    BOpenGL: TButton;
    BSingleRecord: TButton;
    Button1: TButton;
    procedure Button20Click(Sender: TObject);
    procedure BNewSeriesClick(Sender: TObject);
    procedure BSingleRecordClick(Sender: TObject);
    procedure BOpenGLClick(Sender: TObject);
    procedure BGradientClick(Sender: TObject);
    procedure BDepthAxisClick(Sender: TObject);
    procedure BMultiLabelsClick(Sender: TObject);
    procedure BMultiAxisClick(Sender: TObject);
    procedure BLogAxisClick(Sender: TObject);
    procedure BDraw3DClick(Sender: TObject);
    procedure BMultiRowLegendClick(Sender: TObject);
    procedure BFuncRangeClick(Sender: TObject);
    procedure BBackWallClick(Sender: TObject);
    procedure BEditorClick(Sender: TObject);
    procedure BPreviewerClick(Sender: TObject);
    procedure BArrayClick(Sender: TObject);
    procedure BMarksClick(Sender: TObject);
    procedure BZOrderClick(Sender: TObject);
    procedure BCandleClick(Sender: TObject);
    procedure BExplodedClick(Sender: TObject);
    procedure BOtherPieClick(Sender: TObject);
    procedure BCommanderClick(Sender: TObject);
    procedure BListBoxClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure ShowForm(AFormClass:TFormClass);
  end;

implementation

uses Menupro, UGradien, UDepAx, UMulab, ULogLa, udraw3d, UMulLeg,
  UFunRan, UBackWa, UChaEd, UChaPre, UArray, UMulMa, UZOrd, UCand3D,
  UMultiAx, UExpPie, uothpie, ucomma, ulistbo, TeeAbout
  {$IFNDEF NOUSE_BDE}
  ,USingRec
  {$ENDIF}
  ;

{$R *.DFM}

Procedure TMenuExtended.ShowForm(AFormClass:TFormClass);
Begin
  With AFormClass.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;
End;

procedure TMenuExtended.Button20Click(Sender: TObject);
begin
  Close;
end;

procedure TMenuExtended.BNewSeriesClick(Sender: TObject);
Var SeriesForm:TExtendedSeriesForm;
begin
  SeriesForm:=TExtendedSeriesForm.Create(Self);
  try
    SeriesForm.ShowModal;
  finally
    SeriesForm.Free;
  end;
end;

procedure TMenuExtended.BSingleRecordClick(Sender: TObject);
begin
  {$IFDEF NOUSE_BDE}
  ShowMessage('Download the Database Demo from www.teemach.com. Thank You.');
  {$ELSE}
  ShowForm(TFormDBSingleRecord);
  {$ENDIF}
end;

procedure TMenuExtended.BOpenGLClick(Sender: TObject);
begin
  ShowMessage('New OpenGL 3D rendering features are located'+#13+
              'in a separated example project executable.'+#13+#13+
              'Download the OpenGL TeeChart Pro 4 demo from'+#13+
              'our web site at http://www.teemach.com');
end;

procedure TMenuExtended.BGradientClick(Sender: TObject);
begin
  ShowForm(TGradientForm);
end;

procedure TMenuExtended.BDepthAxisClick(Sender: TObject);
begin
  ShowForm(TDepthAxisForm);
end;

procedure TMenuExtended.BMultiLabelsClick(Sender: TObject);
begin
  ShowForm(TMultiLineLabelsForm);
end;

procedure TMenuExtended.BMultiAxisClick(Sender: TObject);
begin
  ShowForm(TFormMenuMultiAxes);
end;

procedure TMenuExtended.BLogAxisClick(Sender: TObject);
begin
  ShowForm(TLogLabelsForm);
end;

procedure TMenuExtended.BDraw3DClick(Sender: TObject);
begin
  ShowForm(TDraw3DForm);
end;

procedure TMenuExtended.BMultiRowLegendClick(Sender: TObject);
begin
  ShowForm(TMultiRowLegendForm);
end;

procedure TMenuExtended.BFuncRangeClick(Sender: TObject);
begin
  ShowForm(TFunctionRangeForm);
end;

procedure TMenuExtended.BBackWallClick(Sender: TObject);
begin
  ShowForm(TBackWall3DForm);
end;

procedure TMenuExtended.BEditorClick(Sender: TObject);
begin
  ShowForm(TChartEditorForm);
end;

procedure TMenuExtended.BPreviewerClick(Sender: TObject);
begin
  ShowForm(TChartPreviewForm);
end;

procedure TMenuExtended.BArrayClick(Sender: TObject);
begin
  ShowForm(TArrayForm);
end;

procedure TMenuExtended.BMarksClick(Sender: TObject);
begin
  ShowForm(TMultiMarksForm);
end;

procedure TMenuExtended.BZOrderClick(Sender: TObject);
begin
  ShowForm(TZOrderForm);
end;

procedure TMenuExtended.BCandleClick(Sender: TObject);
begin
  ShowForm(TCandle3DForm);
end;

procedure TMenuExtended.BExplodedClick(Sender: TObject);
begin
  ShowForm(TExplodedPieForm);
end;

procedure TMenuExtended.BOtherPieClick(Sender: TObject);
begin
  ShowForm(TOtherPieForm);
end;

procedure TMenuExtended.BCommanderClick(Sender: TObject);
begin
  ShowForm(TCommanderForm);
end;

procedure TMenuExtended.BListBoxClick(Sender: TObject);
begin
  ShowForm(TListBoxForm);
end;

procedure TMenuExtended.Button1Click(Sender: TObject);
begin
  TeeShowAboutBox(True)
end;

end.
