{*********************************************}
{ TeeChart Delphi Component Library           }
{ Chart BackWall Demo                         }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit UBackWa;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TeEngine, Series, TeeComma, TeeProcs, Chart, ExtCtrls;

type
  TBackWall3DForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    Series1: TBarSeries;
    ShowBackWall: TCheckBox;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    ScrollBar1: TScrollBar;
    procedure Button1Click(Sender: TObject);
    procedure ShowBackWallClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TBackWall3DForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TBackWall3DForm.ShowBackWallClick(Sender: TObject);
begin
  if ShowBackWall.Checked then
  begin
    Chart1.BackWall.Brush.Style:=bsDiagCross;
    Chart1.BackWall.Pen.Visible:=True;
  end
  else
  begin
    Chart1.BackWall.Brush.Style:=bsClear;
    Chart1.BackWall.Pen.Visible:=False;
  end;
end;

procedure TBackWall3DForm.FormCreate(Sender: TObject);
begin
  Series1.FillSampleValues(8);

  { Set BackWall properties... }
  Chart1.BackWall.Brush.Style:=bsDiagCross;
  Chart1.BackWall.Pen.Visible:=True;
end;

procedure TBackWall3DForm.CheckBox1Click(Sender: TObject);
begin
  Chart1.BackWall.Dark3D:=CheckBox1.Checked;
end;

procedure TBackWall3DForm.ScrollBar1Change(Sender: TObject);
begin
  Chart1.BackWall.Size:=ScrollBar1.Position;
end;

end.
