{*********************************************}
{ TeeChart Delphi Component Library           }
{ Bezier Series Demo                          }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit ubezie;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TeEngine, Series, TeeBezie, TeeComma, ExtCtrls, TeeProcs, Chart;

type
  TBezierForm = class(TForm)
    Chart1: TChart;
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    TeeCommander1: TTeeCommander;
    Series1: TBezierSeries;
    CheckBox1: TCheckBox;
    Button2: TButton;
    Label1: TLabel;
    ScrollBar1: TScrollBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}
Uses PenDlg;

procedure TBezierForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TBezierForm.Button2Click(Sender: TObject);
begin
  EditChartPen(Self,Series1.LinePen);
end;

procedure TBezierForm.CheckBox1Click(Sender: TObject);
begin
  Series1.Pointer.Visible:=CheckBox1.Checked;
end;

procedure TBezierForm.FormCreate(Sender: TObject);
var t:Integer;
begin
  Series1.Clear;
  for t:=1 to 30 do Series1.Add( Random(1000), '', clTeeColor);
end;

procedure TBezierForm.ScrollBar1Change(Sender: TObject);
begin
  Series1.NumBezierPoints:=ScrollBar1.Position;
end;

end.
