{*********************************************}
{ TeeChart Delphi Component Library           }
{ Editor Component Demo                       }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
{$I Teedefs.inc}
unit UChaEd;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, TeeEdit, Series, TeEngine, TeeProcs, Chart, ExtCtrls;

type
  TChartEditorForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    Chart1: TChart;
    Series4: TAreaSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series1: TBarSeries;
    ChartEditor1: TChartEditor;
    BShow: TBitBtn;
    Panel2: TPanel;
    Label2: TLabel;
    ComboBoxTabs: TComboBox;
    Label3: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    CBShowMain: TCheckBox;
    CBShowGeneral: TCheckBox;
    CBShowAxis: TCheckBox;
    CBShowTitles: TCheckBox;
    CBShowLegend: TCheckBox;
    CBShowPanel: TCheckBox;
    CBShowPaging: TCheckBox;
    CBShowWalls: TCheckBox;
    CBShow3D: TCheckBox;
    CBShowSeriesGeneral: TCheckBox;
    CBShowSeriesMarks: TCheckBox;
    GroupBox1: TGroupBox;
    AddCheckBox: TCheckBox;
    DeleteCheckBox: TCheckBox;
    ChangeCheckBox: TCheckBox;
    CloneCheckBox: TCheckBox;
    TitleCheckBox: TCheckBox;
    DataSourceCheckBox: TCheckBox;
    HelpCheckBox: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure BShowClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CBShowMainClick(Sender: TObject);
    procedure ComboBoxTabsChange(Sender: TObject);
    procedure AddCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

{ This unit (IEditCha) is necessary to access the
  editor options constants }

{$IFDEF WIN32}
Uses IEditCha;
{$ELSE}
Uses IEdit16;
{$ENDIF}

procedure TChartEditorForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TChartEditorForm.BShowClick(Sender: TObject);
begin
  ChartEditor1.Title:=Edit1.Text;  { <-- change Editor Title }

  ChartEditor1.Execute;  { <---- show editor ! }
end;

procedure TChartEditorForm.FormCreate(Sender: TObject);
begin
  { sample random data }
  Series1.FillSampleValues(5);
  Series2.FillSampleValues(5);
  Series3.FillSampleValues(5);
  Series4.FillSampleValues(5);

  { default tab is Main }
  ComboBoxTabs.ItemIndex:=0;
end;

procedure TChartEditorForm.CBShowMainClick(Sender: TObject);
Var Option:TChartEditorTab;
begin
  Option:=cetMain;

  if Sender=CBShowMain then Option:=cetMain else
  if Sender=CBShowGeneral then Option:=cetGeneral else
  if Sender=CBShowAxis then Option:=cetAxis else
  if Sender=CBShowTitles then Option:=cetTitles else
  if Sender=CBShowLegend then Option:=cetLegend else
  if Sender=CBShowPanel then Option:=cetPanel else
  if Sender=CBShowPaging then Option:=cetPaging else
  if Sender=CBShowWalls then Option:=cetWalls else
  if Sender=CBShow3D then Option:=cet3D else
  if Sender=CBShowSeriesGeneral then Option:=cetSeriesGeneral else
  if Sender=CBShowSeriesMarks then Option:=cetSeriesMarks;

  With ChartEditor1 do
  if (Sender as TCheckBox).Checked then HideTabs:=HideTabs-[Option]
                                   else HideTabs:=HideTabs+[Option]
end;

procedure TChartEditorForm.ComboBoxTabsChange(Sender: TObject);
begin
  ChartEditor1.DefaultTab:=TChartEditorTab(ComboBoxTabs.ItemIndex);
end;

procedure TChartEditorForm.AddCheckBoxClick(Sender: TObject);
Var Option:TChartEditorOption;
begin
  Option:=ceAdd;
  if Sender=AddCheckBox then Option:=ceAdd else
  if Sender=DeleteCheckBox then Option:=ceDelete else
  if Sender=ChangeCheckBox then Option:=ceChange else
  if Sender=CloneCheckBox then Option:=ceClone else
  if Sender=DataSourceCheckBox then Option:=ceDataSource else
  if Sender=TitleCheckBox then Option:=ceTitle;
  {$IFNDEF D1}
  if Sender=HelpCheckBox then Option:=ceHelp;
  {$ENDIF}

  With ChartEditor1 do
  if (Sender as TCheckBox).Checked then Options:=Options+[Option]
                                   else Options:=Options-[Option]
end;

end.
