{*********************************************}
{ TeeChart Delphi Component Library           }
{ Commander Toolbar Demo                      }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit ucomma;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeeSurfa, TeePoin3, ErrorBar, CandleCh, Series, TeEngine, TeeProcs,
  Chart, TeeComma, StdCtrls, ExtCtrls;

type
  TCommanderForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    TeeCommander1: TTeeCommander;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Series3: TBarSeries;
    Series4: TAreaSeries;
    Series5: TFastLineSeries;
    Series6: TVolumeSeries;
    Series7: TErrorSeries;
    CheckBox1: TCheckBox;
    Pie: TPieSeries;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TCommanderForm.FormCreate(Sender: TObject);
begin
 { Important property:

   TeeCommander1.Panel := Chart1 ;
 }

  Series1.FillSampleValues(20);
  Series2.FillSampleValues(30);
  Series3.FillSampleValues(10);
  Series4.FillSampleValues(10);
  Series5.FillSampleValues(30);
  Series6.FillSampleValues(30);
  Series7.FillSampleValues(10);
  Pie.FillSampleValues(8);

  TeeCommander1.ButtonRotate.Down:=True;

  { Show a Pie Series only by default }
  CheckBox1.Checked:=True;
  CheckBox1Click(Self);
end;

procedure TCommanderForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TCommanderForm.CheckBox1Click(Sender: TObject);
begin
  Pie.Active:=CheckBox1.Checked;
  Series1.Active:=not Pie.Active;
  Series2.Active:=not Pie.Active;
  Series3.Active:=not Pie.Active;
  Series4.Active:=not Pie.Active;
  Series5.Active:=not Pie.Active;
  Series6.Active:=not Pie.Active;
  Series7.Active:=not Pie.Active;

  if not Pie.Active then
  With Chart1.View3DOptions do
  begin
    Rotation:=315;
    Elevation:=315;
  end;
end;

procedure TCommanderForm.CheckBox2Click(Sender: TObject);
begin
  TeeCommander1.LabelValues:=CheckBox2.Checked;
end;

end.
