{*********************************************}
{ TeeChart Delphi Component Library           }
{ Exploding Pie Slices Demo                   }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit UExpPie;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TeEngine, Series, TeeProcs, Chart, TeeComma;

type
  TExplodedPieForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    ScrollBar1: TScrollBar;
    TeeCommander1: TTeeCommander;
    Chart1: TChart;
    Series1: TPieSeries;
    Button2: TButton;
    CheckBox2: TCheckBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TExplodedPieForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TExplodedPieForm.CheckBox1Click(Sender: TObject);
begin
  Chart1.View3D:=CheckBox1.Checked;
end;

procedure TExplodedPieForm.ScrollBar1Change(Sender: TObject);
begin
  { set the exploding of the biggest pie slice }
  Series1.ExplodeBiggest:=ScrollBar1.Position;
end;

procedure TExplodedPieForm.Button2Click(Sender: TObject);
var t:Integer;
begin
  { reset all slices to exploding zero }
  for t:=0 to Series1.Count-1 do Series1.ExplodedSlice.Value[t]:=0;
  
  { un-explode the biggest slice too... }
  Series1.ExplodeBiggest:=0;

  ScrollBar1.Position:=0;
end;

procedure TExplodedPieForm.FormCreate(Sender: TObject);
var t:Integer;
begin
  Series1.FillSampleValues(8);

  { Explode all Pie slices }
  for t:=0 to Series1.Count-1 do
      Series1.ExplodedSlice.Value[t]:=10*t;
end;

procedure TExplodedPieForm.Timer1Timer(Sender: TObject);
begin
  Series1.RotationAngle:=Series1.RotationAngle+5;
end;

procedure TExplodedPieForm.CheckBox2Click(Sender: TObject);
begin
  Timer1.Enabled:=CheckBox2.Checked;
end;

end.
