{*********************************************}
{ TeeChart Delphi Component Library           }
{ Chart List Box Demo                         }
{ Copyright (c) 1995-1998 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit ulistbo;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Series, TeEngine, TeeProcs, Chart, TeeLisB, TeeComma, ExtCtrls;

type
  TListBoxForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    TeeCommander1: TTeeCommander;
    ChartListBox1: TChartListBox;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TBarSeries;
    Series3: TPointSeries;
    Series4: TFastLineSeries;
    Series6: TLineSeries;
    Series7: TLineSeries;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

Uses BrushDlg;

procedure TListBoxForm.Button2Click(Sender: TObject);
begin
  { nothing special. just a private method to show the
    standard Delphi FontDialog }
  InternalEditFont(Self,ChartListBox1.Font);
end;

procedure TListBoxForm.CheckBox4Click(Sender: TObject);
begin
  ChartListBox1.ShowSeriesTitle:=CheckBox4.Checked;
end;

procedure TListBoxForm.CheckBox2Click(Sender: TObject);
begin
  ChartListBox1.ShowSeriesColor:=CheckBox2.Checked;
end;

procedure TListBoxForm.CheckBox1Click(Sender: TObject);
begin
  ChartListBox1.ShowActiveCheck:=CheckBox1.Checked;
end;

procedure TListBoxForm.CheckBox3Click(Sender: TObject);
begin
  ChartListBox1.ShowSeriesIcon:=CheckBox3.Checked;
end;

procedure TListBoxForm.FormCreate(Sender: TObject);
begin
  { fill sample values. Some series are missing intentionally,
    to show at the list-box }
  Series1.FillSampleValues(20);
  Series3.FillSampleValues(10);
  Series4.FillSampleValues(20);
  Series6.FillSampleValues(20);
  Series7.FillSampleValues(20);
  Series2.FillSampleValues(6);

  { change the default Toolbar button to be the
    rotate button. }

  TeeCommander1.ButtonRotate.Down:=True;
end;

procedure TListBoxForm.Button1Click(Sender: TObject);
begin
  Close;
end;

end.
