{****************************************}
{    TeeChart. TChart Component          }
{ Copyright (c) 1995-98 by David Berneda }
{    All Rights Reserved                 }
{****************************************}
unit ULogLa;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, TeeProcs, Chart, StdCtrls, ExtCtrls;

type
  TLogLabelsForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    Chart1: TChart;
    Series1: TAreaSeries;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TLogLabelsForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TLogLabelsForm.CheckBox3Click(Sender: TObject);
begin
  Series1.GetHorizAxis.Logarithmic:=CheckBox3.Checked;
end;

procedure TLogLabelsForm.CheckBox1Click(Sender: TObject);
begin
  Series1.GetVertAxis.Logarithmic:=CheckBox1.Checked;
end;

procedure TLogLabelsForm.FormCreate(Sender: TObject);
var t:Integer;
    tmp:Double;
begin
  { add some positive sample random values, so we can see
    good logarithmic labels... }
  tmp:=Random(100);
  Series1.Clear;
  for t:=1 to 100 do
  begin
    tmp:=tmp+Abs(Random(10000)-5000);
    Series1.AddXY(t*10,tmp,'',clTeeColor);
  end;
end;

procedure TLogLabelsForm.CheckBox2Click(Sender: TObject);
begin
  { change the axis labels format specifier string... }
  if CheckBox2.Checked then
  begin
    Chart1.LeftAxis.AxisValuesFormat:='0E+';
    Chart1.BottomAxis.AxisValuesFormat:='0E+';
  end
  else
  begin
    Chart1.LeftAxis.AxisValuesFormat:='#,##0.#############';
    Chart1.BottomAxis.AxisValuesFormat:='#,##0.#############';
  end;
end;

end.
