{****************************************}
{    TeeChart. TChart Component          }
{ Copyright (c) 1995-98 by David Berneda }
{    All Rights Reserved                 }
{****************************************}
unit UMulMa;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TeEngine, Series, TeeProcs, Chart, TeeComma;

type
  TMultiMarksForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    Chart1: TChart;
    Series1: TPieSeries;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Button3: TButton;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Chart1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
    Dragged:Integer;
    OldX,OldY:Integer;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}
Uses EditChar;

procedure TMultiMarksForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TMultiMarksForm.FormCreate(Sender: TObject);
begin
  Dragged:=-1;
  Series1.FillSampleValues(8);
end;

procedure TMultiMarksForm.Chart1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var DifX,DifY:Integer;
begin
  if Dragged<>-1 then
  With Series1.Marks.Positions.Position[Dragged] do
  begin
    DifX:=X-OldX;
    DifY:=Y-OldY;
    Custom:=True;
    Inc(LeftTop.X,DifX);
    Inc(LeftTop.Y,DifY);
    Inc(ArrowTo.X,DifX);
    Inc(ArrowTo.Y,DifY);
    OldX:=X;
    OldY:=Y;
    Series1.Repaint;
    Button3.Enabled:=True;
  end
  else
  begin
    if Series1.Marks.Clicked(x,y)<>-1 then
    begin
      Chart1.Cursor:=crTeeHand;
      Chart1.OriginalCursor:=crTeeHand;
    end
    else
    if Chart1.Cursor<>crDefault then
    begin
      Chart1.Cursor:=crDefault;
      Chart1.OriginalCursor:=crDefault;
    end;
  end;
end;

procedure TMultiMarksForm.Chart1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Dragged:=Series1.Marks.Clicked(x,y);
  OldX:=X;
  OldY:=Y;
end;

procedure TMultiMarksForm.Chart1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Dragged:=-1;
end;

procedure TMultiMarksForm.Button2Click(Sender: TObject);
begin
  EditChart(Self,Chart1);
end;

procedure TMultiMarksForm.CheckBox1Click(Sender: TObject);
begin
  Series1.Marks.Arrow.Visible:=CheckBox1.Checked;
end;

procedure TMultiMarksForm.Button3Click(Sender: TObject);
var t:Integer;
begin
  With Series1 do
  for t:=0 to Count-1 do
      Marks.Positions.Position[t].Custom:=False;
  Button3.Enabled:=False;
  Chart1.Repaint;
end;

procedure TMultiMarksForm.CheckBox2Click(Sender: TObject);
begin
  TeeCheckMarkArrowColor:=CheckBox2.Checked;
  Chart1.Repaint;
end;

end.
