{****************************************}
{    TeeChart. TChart Component          }
{ Copyright (c) 1995-98 by David Berneda }
{    All Rights Reserved                 }
{****************************************}
unit upo3d;

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TeEngine, TeeSurfa, TeePoin3, TeeProcs, Chart, TeeComma,
  ExtCtrls;

type
  TPoint3DForm = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    TeeCommander1: TTeeCommander;
    Chart1: TChart;
    Series1: TPoint3DSeries;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Timer1: TTimer;
    CheckBox5: TCheckBox;
    Panel1: TPanel;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
  private
    { Private declarations }
    DeltaR:Integer;
    DeltaE:Integer;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TPoint3DForm.CheckBox1Click(Sender: TObject);
begin
  Series1.LinePen.Visible:=CheckBox1.Checked;
end;

procedure TPoint3DForm.CheckBox2Click(Sender: TObject);
begin
  Series1.Pointer.Visible:=CheckBox2.Checked;
end;

procedure TPoint3DForm.CheckBox3Click(Sender: TObject);
begin
  Series1.ColorEachPoint:=CheckBox3.Checked;
end;

procedure TPoint3DForm.FormCreate(Sender: TObject);
begin
  DeltaR:=-5;
  DeltaE:=-4;
  Series1.FillSampleValues(100);
end;

procedure TPoint3DForm.CheckBox4Click(Sender: TObject);
begin
  Timer1.Enabled:=CheckBox4.Checked;
end;

procedure TPoint3DForm.Timer1Timer(Sender: TObject);
begin
  With Chart1.View3DOptions do
  begin
    Rotation:=Rotation+DeltaR;
    if (Rotation<280) or (Rotation>350) then DeltaR:=-DeltaR;
    Elevation:=Elevation+DeltaE;
    if (Elevation<280) or (Elevation>350) then DeltaE:=-DeltaE;
  end;
end;

procedure TPoint3DForm.Button1Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  Close;
end;

procedure TPoint3DForm.CheckBox5Click(Sender: TObject);
begin
  Chart1.View3DWalls:=CheckBox5.Checked;
end;

end.
