{****************************************}
{    TeeChart. TChart Component          }
{ Copyright (c) 1995-98 by David Berneda }
{    All Rights Reserved                 }
{****************************************}
unit UPointer;

interface

uses
  Wintypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls;

type
  TDrawPointerForm = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Every: TScrollBar;
    Button1: TButton;
    Label4: TLabel;
    Label5: TLabel;
    StartAt: TScrollBar;
    Colorize: TCheckBox;
    function Series1GetPointerStyle(Sender: TChartSeries;
      ValueIndex: Longint): TSeriesPointerStyle;
    procedure FormCreate(Sender: TObject);
    procedure EveryChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ColorizeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DrawPointerForm: TDrawPointerForm;

implementation

{$R *.DFM}

function TDrawPointerForm.Series1GetPointerStyle(Sender: TChartSeries;
  ValueIndex: Longint): TSeriesPointerStyle;
begin
  if (ValueIndex>=StartAt.Position) and
     (((ValueIndex-StartAt.Position) mod Every.Position) = 0) then  { <-- enable/disable pointers }
     result:=psRectangle
  else
     result:=psSmallDot;

  if Colorize.Checked then
     Series1.Pointer.Brush.Color:=GetDefaultColor(ValueIndex);
end;

procedure TDrawPointerForm.FormCreate(Sender: TObject);
begin
  Series1.FillSampleValues(100);
end;

procedure TDrawPointerForm.EveryChange(Sender: TObject);
begin
  Label2.Caption:=IntToStr(Every.Position);
  Label5.Caption:=IntToStr(StartAt.Position);
  Chart1.Repaint;
end;

procedure TDrawPointerForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TDrawPointerForm.ColorizeClick(Sender: TObject);
begin
  Chart1.Repaint;
end;

end.
