unit Usyncz;

interface

uses
  Wintypes,WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls;

type
  TSynchroZoomForm = class(TForm)
    Chart1: TChart;
    Chart2: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Panel1: TPanel;
    Button1: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Chart1Zoom(Sender: TObject);
    procedure Chart1Scroll(Sender: TObject);
    procedure Chart2Scroll(Sender: TObject);
    procedure Chart2Zoom(Sender: TObject);
    procedure Chart1UndoZoom(Sender: TObject);
    procedure Chart2UndoZoom(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure AssignScales(Source,Dest:TCustomChart);
  end;

var
  SynchroZoomForm: TSynchroZoomForm;

implementation

{$R *.DFM}

Procedure TSynchroZoomForm.AssignScales(Source,Dest:TCustomChart);
begin
  With Source.LeftAxis do Dest.LeftAxis.SetMinMax(Minimum,Maximum);
  With Source.TopAxis do Dest.TopAxis.SetMinMax(Minimum,Maximum);
  With Source.RightAxis do Dest.RightAxis.SetMinMax(Minimum,Maximum);
  With Source.BottomAxis do Dest.BottomAxis.SetMinMax(Minimum,Maximum);
end;

procedure TSynchroZoomForm.FormCreate(Sender: TObject);
begin
  Series1.FillSampleValues(100);
  Series2.AssignValues(Series1);
end;

procedure TSynchroZoomForm.Chart1Zoom(Sender: TObject);
begin
  AssignScales(Chart1,Chart2);
end;

procedure TSynchroZoomForm.Chart1Scroll(Sender: TObject);
begin
  AssignScales(Chart1,Chart2);
end;

procedure TSynchroZoomForm.Chart1UndoZoom(Sender: TObject);
begin
  AssignScales(Chart1,Chart2);
end;

procedure TSynchroZoomForm.Chart2Scroll(Sender: TObject);
begin
  AssignScales(Chart2,Chart1);
end;

procedure TSynchroZoomForm.Chart2Zoom(Sender: TObject);
begin
  AssignScales(Chart2,Chart1);
end;

procedure TSynchroZoomForm.Chart2UndoZoom(Sender: TObject);
begin
  AssignScales(Chart2,Chart1);
end;

procedure TSynchroZoomForm.Button1Click(Sender: TObject);
begin
  Close;
end;

end.
