unit utwoclip;
{$I teedefs.inc}

interface

{ This example merges two Charts into a single metafile object,
  then copies the metafile to clipboard.

  FOR Delphi 2.0 and 3.0 ONLY  ( 32-bit Windows 95 or NT )
}
uses
  Wintypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, StdCtrls, Buttons, ExtCtrls, TeeProcs, Chart;

type
  TClipboardTwoForm = class(TForm)
    Chart1: TChart;
    Chart2: TChart;
    BitBtn1: TBitBtn;
    Series1: TBarSeries;
    Button1: TButton;
    Series2: TAreaSeries;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ClipboardTwoForm: TClipboardTwoForm;

implementation

{$R *.DFM}
Uses Clipbrd;

procedure TClipboardTwoForm.BitBtn1Click(Sender: TObject);
Var Meta      : TMetafile;
    {$IFNDEF D1}
    tmpCanvas : TMetafileCanvas; { <-- for 32-bit only ! }
    {$ENDIF}
begin
  Meta:=TMetafile.Create;  { create a temporary metafile image }
  try
    Meta.Width:=200;        { set metafile dimensions }
    Meta.Height:=210;
    {$IFNDEF D1}
    Meta.Enhanced:=True;
    tmpCanvas:=TMetafileCanvas.Create(Meta,0);  { create a temporary canvas }
    try
      { draw first chart }
      Chart1.DrawToMetaCanvas(tmpCanvas,Rect(0,0,200,100));
      { draw second chart }
      Chart2.DrawToMetaCanvas(tmpCanvas,Rect(0,110,200,210));
    finally
      tmpCanvas.Free;       { destroy the temporary canvas }
    end;
    {$ENDIF}
    Clipboard.Assign(Meta);  { copy the metafile to clipboard }
  finally
    Meta.Free;  { destroy the temporary metafile }
  end;
end;

procedure TClipboardTwoForm.FormCreate(Sender: TObject);
begin
  Series1.FillSampleValues(5);
  Series2.FillSampleValues(5);
end;

procedure TClipboardTwoForm.Button1Click(Sender: TObject);
begin
  Close;
end;

end.
