{**********************************************}
{   TeeChart                                   }
{   Neural Net Example                         }
{   Copyright (c) 1995-1996 by David Berneda   }
{**********************************************}
unit Usurfac;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Teengine, TeeSurfa, ExtCtrls, Chart, StdCtrls, Buttons,
  Series, TeeProcs, TeeComma;

type
  TSurfaceWeights = class(TForm)
    Chart1: TChart;
    SurfaceSeries1: TSurfaceSeries;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    ScrollBar1: TScrollBar;
    CheckBox3: TCheckBox;
    Label1: TLabel;
    Timer1: TTimer;
    TeeCommander1: TTeeCommander;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    tmpDelta:Integer;
  end;

var
  SurfaceWeights: TSurfaceWeights;

implementation

{$R *.DFM}
Uses EditPro,EditChar;

procedure TSurfaceWeights.CheckBox1Click(Sender: TObject);
begin
  Chart1.View3D:=CheckBox1.Checked;
end;

procedure TSurfaceWeights.CheckBox2Click(Sender: TObject);
begin
  Chart1.BufferedDisplay:=not CheckBox2.Checked;
end;

procedure TSurfaceWeights.BitBtn2Click(Sender: TObject);
begin
  EditSeries(Self,SurfaceSeries1);
end;

procedure TSurfaceWeights.BitBtn3Click(Sender: TObject);
begin
  EditChart(Self,Chart1);
end;

procedure TSurfaceWeights.ScrollBar1Change(Sender: TObject);
begin
  Chart1.View3DOptions.Rotation:=ScrollBar1.Position;
end;

procedure TSurfaceWeights.CheckBox3Click(Sender: TObject);
begin
  Timer1.Enabled:=CheckBox3.Checked;
  if Timer1.Enabled then tmpDelta:=2;
end;

procedure TSurfaceWeights.Timer1Timer(Sender: TObject);
var tmp:Integer;
begin
  tmp:=ScrollBar1.Position;
  if ((tmp+tmpDelta)>350) or ((tmp+tmpDelta<280)) then
  begin
    if (tmp+tmpDelta)>350 then tmp:=350 else tmp:=280;
    tmpDelta:=-tmpDelta;
  end
  else tmp:=tmp+tmpDelta;
  ScrollBar1.Position:=tmp;
end;

procedure TSurfaceWeights.FormShow(Sender: TObject);
begin
  Chart1.Gradient.Visible:=Chart1.IsScreenHighColor;
end;

end.
