{*********************************************}
{ TeeChart Delphi Component Library           }
{ Main Form Demo                              }
{ Copyright (c) 1995-1996 by David Berneda    }
{ All rights reserved                         }
{*********************************************}
unit Udemocha;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, StdCtrls, ExtCtrls;

type
  TBasicSeriesForm = class(TForm)
    GroupBox1: TGroupBox;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BStacked: TBitBtn;
    BFastLine: TBitBtn;
    BArrowSeries: TBitBtn;
    BitBtn1: TBitBtn;
    BStackedAreas: TBitBtn;
    BitBtn21: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BStackedClick(Sender: TObject);
    procedure BFastLineClick(Sender: TObject);
    procedure BArrowSeriesClick(Sender: TObject);
    procedure BStackedAreasClick(Sender: TObject);
    procedure BitBtn21Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure ShowForm(AFormClass:TFormClass);
  end;

implementation

{$R *.DFM}
Uses Pie,Bubble,Gantt,Basic,UStack,UFast,UArrows,StackAre,UHighLo;

Procedure TBasicSeriesForm.ShowForm(AFormClass:TFormClass);
Begin
  With AFormClass.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;
End;

procedure TBasicSeriesForm.BitBtn4Click(Sender: TObject);
begin
  ShowForm(TBasicForm);
end;

procedure TBasicSeriesForm.BitBtn5Click(Sender: TObject);
begin
  ShowForm(TPieForm);
end;

procedure TBasicSeriesForm.BitBtn6Click(Sender: TObject);
begin
  ShowForm(TBubbleForm);
end;

procedure TBasicSeriesForm.BitBtn7Click(Sender: TObject);
begin
  ShowForm(TGanttForm);
end;

Procedure ShowNeedsBDE;
Begin
  ShowMessage('Needs the Borland Database Engine.'+#13+#10+
              'Please email to get the full TeeChart DEMO.');
end;

procedure TBasicSeriesForm.FormCreate(Sender: TObject);
begin
  if Screen.Width<800 then
     ShowMessage('Warning: '+#13+#10+
                 'This Demo is best viewed with a Screen'+#13+#10+
                 'resolution of 800x600 or greater,'+#13+#10+
                 'and a Color Depth of 256 or greater.'+#13+#10+
                 '16K Colors is also better than 256 Colors.');
end;

procedure TBasicSeriesForm.BStackedClick(Sender: TObject);
begin
  ShowForm(TStackedForm);
end;

procedure TBasicSeriesForm.BFastLineClick(Sender: TObject);
begin
  ShowForm(TFastLineForm);
end;

procedure TBasicSeriesForm.BArrowSeriesClick(Sender: TObject);
begin
  ShowForm(TArrowsForm);
end;

procedure TBasicSeriesForm.BStackedAreasClick(Sender: TObject);
begin
  ShowForm(TAreasForm);
end;

procedure TBasicSeriesForm.BitBtn21Click(Sender: TObject);
begin
  ShowForm(THighLowForm);
end;

end.
