{****************************************}
{    TeeChart. TChart Component          }
{ Copyright (c) 1995-98 by David Berneda }
{    All Rights Reserved                 }
{****************************************}
{$I Teedefs.inc}
unit Teeall;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TAllExamplesForm = class(TForm)
    BStdSeriesDemo: TBitBtn;
    BClose: TBitBtn;
    BStdSeries: TBitBtn;
    BDatabase: TBitBtn;
    BTClock: TBitBtn;
    BPacMan: TBitBtn;
    BSpecs: TBitBtn;
    BStdFeatures: TBitBtn;
    BExtFeatures: TBitBtn;
    BExtSeries: TBitBtn;
    BAbout: TBitBtn;
    BNew4: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    procedure BStdSeriesDemoClick(Sender: TObject);
    procedure BStdSeriesClick(Sender: TObject);
    procedure BDatabaseClick(Sender: TObject);
    procedure BTClockClick(Sender: TObject);
    procedure BPacManClick(Sender: TObject);
    procedure BSpecsClick(Sender: TObject);
    procedure BStdFeaturesClick(Sender: TObject);
    procedure BExtFeaturesClick(Sender: TObject);
    procedure BExtSeriesClick(Sender: TObject);
    procedure BCloseClick(Sender: TObject);
    procedure BAboutClick(Sender: TObject);
    procedure BNew4Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AllExamplesForm: TAllExamplesForm;

implementation

{$R *.DFM}
Uses TeeMain,Features,UDemoCha,TeeLoper
     {$IFNDEF NOUSE_BDE}
     ,UTeeDB
     {$ENDIF}
     ,Clock1,UPacMan,Specs,UExtFeat,MenuPro,NewPro4,TeeAbout,
     TeCanvas;

procedure TAllExamplesForm.BStdSeriesDemoClick(Sender: TObject);
begin
  ShowForm(TTeeMainForm);
end;

procedure TAllExamplesForm.BStdSeriesClick(Sender: TObject);
begin
  ShowForm(TBasicSeriesForm);
end;

procedure TAllExamplesForm.BDatabaseClick(Sender: TObject);
begin
  {$IFDEF NOUSE_BDE}
  ShowMessage('The Database Examples are not included in this'+#13+
              'demo executable to avoid requiring the BDE (Borland'+#13+
              'Database Engine).'+#13+
              'Visit http://www.teemach.com to download the TeeChart'+#13+
              'Database Demo.');
  {$ELSE}
  ShowForm(TDatabaseExamples)
  {$ENDIF}
end;

procedure TAllExamplesForm.BTClockClick(Sender: TObject);
begin
  ShowForm(TClockDemoForm);
end;

procedure TAllExamplesForm.BPacManClick(Sender: TObject);
begin
  ShowForm(TTeePacForm)
end;

procedure TAllExamplesForm.BSpecsClick(Sender: TObject);
begin
  ShowForm(TChartSpecs)
end;

procedure TAllExamplesForm.BStdFeaturesClick(Sender: TObject);
begin
  ShowForm(TFeaturesForm)
end;

procedure TAllExamplesForm.BExtFeaturesClick(Sender: TObject);
begin
  ShowForm(TExtendedFeaturesForm);
end;

procedure TAllExamplesForm.BExtSeriesClick(Sender: TObject);
begin
  ShowForm(TExtendedSeriesForm)
end;

procedure TAllExamplesForm.BCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TAllExamplesForm.BAboutClick(Sender: TObject);
begin
  TeeShowAboutBox(True);
end;

procedure TAllExamplesForm.BNew4Click(Sender: TObject);
begin
  ShowForm(TMenuExtended);
end;

procedure TAllExamplesForm.FormPaint(Sender: TObject);
Var tmp:TTeeCanvas3D;
    t:Integer;
    tmpR:TRect;
begin
  With Canvas do
  if (GetDeviceCaps(Handle,BITSPIXEL)*GetDeviceCaps(Handle,PLANES)>=15) then
  begin
    tmp:=TTeeCanvas3D.Create;
    tmp.UseBuffer:=False;
    tmp.ReferenceCanvas:=Canvas;
    tmp.GradientFill(ClientRect,clWhite,clSilver, gdFromTopLeft);
    for t:=0 to ControlCount-1 do
    if Controls[t] is TBitBtn then
    begin
      tmpR:=Controls[t].BoundsRect;
      OffsetRect(tmpR,7,7);
      tmp.GradientFill(tmpR,clSilver,clGray,gdLeftRight);
    end;
    tmp.Free;
  end;
end;

procedure TAllExamplesForm.FormShow(Sender: TObject);
begin
  {$IFDEF D3}
  Image1.Transparent:=True;
  Image2.Transparent:=True;
  {$ENDIF}
end;

end.
