{****************************************}
{    TeeClock Component                  }
{ Copyright (c) 1995-98 by David Berneda }
{    All Rights Reserved                 }
{****************************************}
unit Clock1;
{$I teedefs.inc}

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, TeePolar, TeeRose, TeeProcs, Chart, ExtCtrls,
  StdCtrls, Buttons;

type
  TClockDemoForm = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    LabelHint: TLabel;
    Chart1: TChart;
    Series1: TClockSeries;
    Chart2: TChart;
    ClockSeries1: TClockSeries;
    Chart3: TChart;
    ClockSeries2: TClockSeries;
    Chart4: TChart;
    ClockSeries3: TClockSeries;
    Label4: TLabel;
    Button1: TButton;
    Chart5: TChart;
    ClockSeries4: TClockSeries;
    Chart6: TChart;
    ClockSeries5: TClockSeries;
    LabelWWW: TLabel;
    Timer1: TTimer;
    Bevel1: TBevel;
    Image2: TImage;
    CheckBox1: TCheckBox;
    LabelFeel: TLabel;
    Timer2: TTimer;
    procedure Chart3DblClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart2AfterDraw(Sender: TObject);
    procedure LabelWWWClick(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Delta:Integer;
    DeltaRotation:Integer;
  end;

var
  ClockDemoForm: TClockDemoForm;

implementation

uses Clock2, TeeConst, TeeAbout;

{$R *.DFM}
Const TeeMsg_ClockVersion='TeeClock 1.0';

procedure TClockDemoForm.Chart3DblClick(Sender: TObject);
var t:Integer;
    tmp,tmp2:TChartSeries;
begin
  with TFormTeeClockEditor.Create(Self) do
  try
    Chart1.Assign((Sender as TChart));
    for t:=0 to (Sender as TChart).SeriesCount-1 do
    begin
      tmp2:=(Sender as TChart).Series[t];
      tmp:=CreateNewSeries(FormTeeClockEditor,Chart1,TChartSeriesClass(tmp2.ClassType),nil);
      tmp.Assign(tmp2);
    end;
    Chart1.Align:=alClient;
    ShowModal;
  finally
    Free;
  end;
end;

procedure TClockDemoForm.BitBtn1Click(Sender: TObject);
begin
  With TTeeAboutForm.Create(nil) do
  try
    ClearProducts;
    AddProduct(TeeMsg_ClockVersion,995,500);
    LabelSourceCode.Visible:=False;
    Panel2.Visible:=False;
    LabelVersion.Caption:=TeeMsg_ClockVersion;
    Caption:='About '+TeeMsg_ClockVersion+'...';
    BOrder.Caption:='How to &Licence it ???';
    LabelThanks.Caption:='Thank You for Ordering '+TeeMsg_ClockVersion+' !';
    TeeDefProductName:=TeeMsg_ClockVersion+' VCL';
    Image1.Picture.Assign(Self.Image1.Picture);
    ShowModal;
  finally
    Free;
  end;
end;

procedure TClockDemoForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TClockDemoForm.Timer1Timer(Sender: TObject);

  Function Change(Value,Min,Max:Integer; Var Delta:Integer):Integer;
  begin
    if Delta>0 then
    begin
       if Value<Max then result:=Value+Delta else
       begin
         result:=Max;
         Delta:=-Delta;
       end;
    end
    else
       if Value>Min then result:=Value+Delta else
       begin
         result:=Min;
         Delta:=-Delta;
       end;
  end;

begin
  With Chart4.View3DOptions do
       Zoom:=Change(Zoom,70,200,Delta);
  With Chart6.View3DOptions do
       Rotation:=Change(Rotation,270,360,DeltaRotation);
end;

procedure TClockDemoForm.FormCreate(Sender: TObject);
begin
  Delta:=5;
  DeltaRotation:=1;
  ClockSeries5.Pointer.Visible:=True;
  if not Chart1.IsScreenHighColor then
     ShowMessage('Warning: Much better viewed with more than 256 colors'+#13+
     'video mode.');
end;

procedure TClockDemoForm.Chart2AfterDraw(Sender: TObject);
begin
  if Chart2.Foot.Text[0]<>TimeToStr(Now) then
     Chart2.Foot.Text[0]:=TimeToStr(Now);
end;

procedure TClockDemoForm.LabelWWWClick(Sender: TObject);
begin
 {$IFNDEF D1}
  GotoURL(Handle,LabelWWW.Caption);
 {$ENDIF}
end;

procedure TClockDemoForm.Image2Click(Sender: TObject);
begin
  LabelWWWClick(Self);
end;

procedure TClockDemoForm.FormPaint(Sender: TObject);
var t,tt:Integer;
begin
  if not CheckBox1.Checked then
  With Canvas do
  for t:=0 to ClientWidth do
  for tt:=0 to ClientHeight do
   if ((t mod 8)=0) and ((tt mod 8)=0) then
      Pixels[t,tt]:=clBlue;
end;

procedure TClockDemoForm.CheckBox1Click(Sender: TObject);
begin
  RePaint;
end;

procedure TClockDemoForm.Timer2Timer(Sender: TObject);
begin
  LabelHint.Visible:=not LabelHint.Visible;
  LabelFeel.Visible:=not LabelHint.Visible;
end;

end.
