unit Clock2;
{$I teedefs.inc}

interface

uses
  WinProcs,WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, TeeProcs, TeEngine, Chart, TeeComma, StdCtrls, TeeRose, TeeEdit;

type
  TFormTeeClockEditor = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    ChartEditor1: TChartEditor;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
    Function Clock:TClockSeries;
  public
    { Public declarations }
  end;

var
  FormTeeClockEditor: TFormTeeClockEditor;

implementation

{$R *.DFM}
Uses PenDlg, BrushDlg
     {$IFNDEF D1}
     , IEditCha, IEdiGene
     {$ENDIF};

Function TFormTeeClockEditor.Clock:TClockSeries;
begin
  result:=(Chart1[0] as TClockSeries)
end;

procedure TFormTeeClockEditor.FormCreate(Sender: TObject);
begin
  With TeeCommander1 do
  begin
    ButtonNormal.Visible:=False;
    ButtonDepth.Visible:=False;
    ButtonRotate.Down:=True;
    ShowValues;
    ChartEditor:=ChartEditor1;
  end;
end;

procedure TFormTeeClockEditor.CheckBox1Click(Sender: TObject);
begin
  Clock.CircleLabels:=CheckBox1.Checked;
  RadioGroup1.Enabled:=Clock.CircleLabels;
  Button1.Enabled:=Clock.CircleLabels;
end;

procedure TFormTeeClockEditor.Button2Click(Sender: TObject);
begin
  With Clock do CircleBackColor:=EditColor(Self,CircleBackColor);
end;

procedure TFormTeeClockEditor.Button3Click(Sender: TObject);
begin
  EditChartPen(Self,Clock.CirclePen);
end;

procedure TFormTeeClockEditor.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex=0 then
     Clock.Style:=cssRoman
  else
     Clock.Style:=cssDecimal
end;

procedure TFormTeeClockEditor.Button4Click(Sender: TObject);
begin
  EditChartPen(Self,Chart1.BottomAxis.Grid);
end;

procedure TFormTeeClockEditor.Button1Click(Sender: TObject);
begin
  InternalEditFont(Self,Clock.CircleLabelsFont);
end;

procedure TFormTeeClockEditor.FormShow(Sender: TObject);
begin
  CheckBox1.Checked:=Clock.CircleLabels;
  CheckBox1Click(Self);
  if Clock.Style=cssRoman then
     RadioGroup1.ItemIndex:=0
  else
     RadioGroup1.ItemIndex:=1;
end;

procedure TFormTeeClockEditor.Button5Click(Sender: TObject);
begin
  EditChartPen(Self,Clock.PenSeconds);
end;

procedure TFormTeeClockEditor.Button6Click(Sender: TObject);
begin
  EditChartBrush(Self,Clock.Brush);
end;

procedure TFormTeeClockEditor.Button7Click(Sender: TObject);
begin
  ChartEditor1.Execute;
end;

procedure TFormTeeClockEditor.CheckBox2Click(Sender: TObject);
begin
  Clock.Circled:=not CheckBox2.Checked;
end;

end.
